// test_starrect.cpp
// Glenn G. Chappell
// 19 Sep 2013
//
// For CS 202 Fall 2013
// Test program for class StarRect

#include "starrect.h"  // For class StarRect
#include "starrect.h"  // Double-inclusion test

#include <iostream>
using std::cout;
using std::endl;
using std::cin;
#include <string>
using std::string;
#include <sstream>
using std::ostringstream;


bool allGood = true;  // true if all tests pass so far


// testStarRect1
// Test #1 for class StarRect
// Prints results of tests, sets global allGood to false if any fail
void testStarRect1()
{
    cout << endl;
    cout << "Test 1" << endl;

    StarRect s(5, 3);
    const StarRect & cs(s);

    int w = cs.getWidth();
    cout << "Width (should be 5): " << w << endl;
    if (w != 5)
    {
        allGood = false;
    }

    int h = cs.getHeight();
    cout << "Height (should be 3): " << h << endl;
    if (h != 3)
    {
        allGood = false;
    }

    ostringstream ostr;
    cs.print(ostr);
    string rect = ostr.str();
    cout << "Rectangle (should be stars, 5 wide, 3 high):" << endl;
    cout << rect;
    if (rect != "*****\n*****\n*****\n")
    {
        allGood = false;
    }
}


// testStarRect2
// Test #2 for class StarRect
// Prints results of tests, sets global allGood to false if any fail
void testStarRect2()
{
    cout << endl;
    cout << "Test 2" << endl;

    StarRect s;
    const StarRect & cs(s);

    s.setHeight(4);
    s.setWidth(1);

    int w = cs.getWidth();
    cout << "Width (should be 1): " << w << endl;
    if (w != 1)
    {
        allGood = false;
    }

    int h = cs.getHeight();
    cout << "Height (should be 4): " << h << endl;
    if (h != 4)
    {
        allGood = false;
    }

    ostringstream ostr;
    cs.print(ostr);
    string rect = ostr.str();
    cout << "Rectangle (should be stars, 1 wide, 4 high):" << endl;
    cout << rect;
    if (rect != "*\n*\n*\n*\n")
    {
        allGood = false;
    }
}


// main program
// Runs tests for class StarRect, prints results
int main()
{
    testStarRect1();
    testStarRect2();
    
    cout << endl;
    if (allGood)
        cout << "All tests pass!" << endl;
    else
        cout << "***** SOME TESTS FAILED *****" << endl;

    cout << endl;
    cout << "Press ENTER to quit ";
    while (cin.get() != '\n') ;

    return 0;
}

